#!/usr/bin/env python

'''
Neb optimization example
'''

from tsase import neb
from tsase.calculators.vasp_ext import Vasp
#from ase.calculators.vasp import Vasp
from ase.io import read
import os
import sys

p1 = read('0.CON',format='vasp')
p2 = read('6.CON',format='vasp')

#calc = LAMMPS(parameters=parameters, tmp_dir="trash")
calc = Vasp(prec = 'Normal', 
            ediff = 1e-5,
            kpts = (4,3,4),
            gamma= True,
            voskown = 1,
            lcharg = False,
            isym = 0,
            npar = 2,
            nsim = 4,
            algo = 'Fast',
            lreal= 'Auto',
            lplane = True,
            encut= 400,
            ismear = 0,
            sigma  = 0.08,
            ldau      = True,
            ldautype  = 2,
            ldauprint = 2,
            ldau_luj = {'Ca':{'L':-1,'U':0,'J':0},'Ir':{'L':2, 'U':3.75, 'J':1.0},'O':{'L':-1,'U':0,'J':0}},
            lmaxmix   = 4
              )
p1.set_calculator(calc)
p2.set_calculator(calc)

nim = 7
pstress = p1.get_cell()*0.0
pstress[2][0] = 9.0
#band = neb.ssneb(p1, p2, numImages = nim, method = 'ci', express = pstress, weight = 1)
#band = neb.ssneb(p1, p2, numImages = nim, dneb = True, express = pstress)
band = neb.ssneb(p1, p2, numImages = nim, express = pstress)
for i in range(1,nim-1):
    filename = str(i)+'.CON'
    b = read(filename,format='vasp')
    band.path[i].set_positions(b.get_positions())
    band.path[i].set_cell(b.get_cell())
    

opt = neb.qm_ssneb(band, maxmove = 0.100, dt = 0.03)
#opt = neb.fire_ssneb(band, maxmove =0.1, dtmax = 0.1, dt=0.1)
opt.minimize(forceConverged=0.01, maxIterations = 100)
os.system('touch movie.con')
for p in range(len(band.path)):
    os.system('cat '+str(p)+'.CON >>movie.con')



